#include <polkit-dbus/polkit-dbus.h>

#include "polkitclient.h"

using namespace PackageKit;

PolkitClient* PolkitClient::m_instance = NULL;
PolkitClient* PolkitClient::instance()
{
	if(!m_instance)
		m_instance = new PolkitClient(qApp);
	return m_instance;
}

PolkitClient::PolkitClient(QObject *parent) : QObject(parent) {
}

bool PolkitClient::getAuth(const QString &action) {
	DBusError e;
	dbus_error_init(&e);

	if(polkit_check_auth(QCoreApplication::applicationPid(), action.toAscii().data(), NULL))
		return true;

	bool auth = polkit_auth_obtain(action.toAscii().data(), 0, QCoreApplication::applicationPid(), &e);
	if(!auth) {
		qDebug() << "Authentification error :" << e.name << ":" << e.message;
	}

	return auth;
}

#include "polkitclient.moc"

